From 63b19b0da5fa866c780c414e7718975749296eee Mon Sep 17 00:00:00 2001
From: Meghan Richardson <mrichard@fedoraproject.org>
Date: Jul 07 2015 16:56:38 +0000
Subject: [PATCH 151/254] Merge branch 'develop' of pagure.io:fedora-hubs into develop


---

diff --git a/hubs/defaults.py b/hubs/defaults.py
index 9646f8e..80f4520 100644
--- a/hubs/defaults.py
+++ b/hubs/defaults.py
@@ -48,7 +48,13 @@ def add_user_widgets(session, hub, username, fullname):
         }))
     hub.widgets.append(widget)
     widget = hubs.models.Widget(
-        plugin='badges', index=4,
+        plugin='subscriptions', index=4,
+        _config=json.dumps({
+            'username': username,
+        }))
+    hub.widgets.append(widget)
+    widget = hubs.models.Widget(
+        plugin='badges', index=5,
         _config=json.dumps({
             'username': username,
         }))
diff --git a/hubs/models.py b/hubs/models.py
index 8c7a51a..9933dd6 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -60,8 +60,7 @@ BASE = declarative_base(cls=HubsBase)
 log = logging.getLogger(__name__)
 
 
-placekitten = lambda: "https://placekitten.com/g/%i/%i" % (
-    random.randint(150,350), random.randint(150, 350))
+placekitten = lambda: "https://placekitten.com/g/320/320"
 
 
 def init(db_url, debug=False, create=False):
@@ -252,10 +251,28 @@ class User(BASE):
         }
 
     @property
+    def ownerships(self):
+        return [assoc.hub for assoc in self.associations
+                if assoc.role == 'owner']
+    @property
+    def memberships(self):
+        return [assoc.hub for assoc in self.associations
+                if assoc.role == 'member' or assoc.role =='owner']
+
+    @property
+    def subscriptions(self):
+        return [assoc.hub for assoc in self.associations
+                if assoc.role == 'subscriber']
+
+    @property
     def username(self):
         return self.openid.split('.')[0]
 
     @classmethod
+    def by_username(cls, session, username):
+        return cls.by_openid(session, "%s.id.fedoraproject.org" % username)
+
+    @classmethod
     def by_openid(cls, session, openid):
         return session.query(cls).filter_by(openid=openid).first()
 
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 5f4d01b..b644707 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -8,6 +8,7 @@ from hubs.widgets import badges
 from hubs.widgets import fedmsgs
 from hubs.widgets import fedmsgstats
 from hubs.widgets import feed
+from hubs.widgets import subscriptions
 
 from hubs.widgets.workflow import pendingacls
 from hubs.widgets.workflow import updates2stable
@@ -25,6 +26,7 @@ registry = {
     'fedmsgs': fedmsgs,
     'fedmsgstats': fedmsgstats,
     'feed': feed,
+    'subscriptions': subscriptions,
 
     'workflow.pendingacls': pendingacls,
     'workflow.updates2stable': updates2stable,
diff --git a/hubs/widgets/badges.py b/hubs/widgets/badges.py
index 4e6234d..1018c3d 100644
--- a/hubs/widgets/badges.py
+++ b/hubs/widgets/badges.py
@@ -1,3 +1,5 @@
+import operator
+
 import requests
 
 from hubs.hinting import hint, prefixed as _
@@ -11,8 +13,9 @@ import hubs.validators as validators
 
 template = jinja2.Template("""
 <div class="flex-container">
-{% for badge in assertions %}
-    <img width="19%" src="{{badge['image']}}"/>
+{% for badge in assertions[:10] %}
+  <a width="60px" href="https://badges.fedoraproject.org/badge/{{badge['id']}}">
+    <img width="60px" src="{{badge['image']}}"/></a>
 {%endfor%}
 </div>
 """)
@@ -29,7 +32,9 @@ def data(session, widget, username):
     url = "https://badges.fedoraproject.org/user/{username}/json"
     url = url.format(username=username)
     response = requests.get(url)
-    return response.json()
+    assertions = response.json()['assertions']
+    key = operator.itemgetter('issued')
+    return dict(assertions=sorted(assertions, key=key, reverse=True))
 
 
 @hint(topics=[_('hubs.widget.update'), _('fedbadges.badge.award')])
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 4550448..995125c 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -42,9 +42,11 @@ def argument(name, default, validator, help):
 def AGPLv3(name):
     def decorator(func):
         @wraps(func)
-        def inner(*args, **kwargs):
-            result = func(*args, **kwargs)
+        def inner(session, widget, *args, **kwargs):
+            result = func(session, widget, *args, **kwargs)
             result['source_url'] = flask.url_for('widget_source', name=name)
+            result['widget_url'] = flask.url_for(
+                'widget_render', hub=widget.hub.name, idx=widget.idx)
             return result
 
         return inner
diff --git a/hubs/widgets/chrome.py b/hubs/widgets/chrome.py
index de38df1..6a313aa 100644
--- a/hubs/widgets/chrome.py
+++ b/hubs/widgets/chrome.py
@@ -8,6 +8,7 @@ _panel_template = jinja2.Template("""
   <div class="pull-right widget-buttons">
     <!-- the AGPLv3 wrapper puts the source url in all responses -->
     <a href="{{source_url}}"><span class="glyphicon glyphicon-eye-open"></span></a>
+    <a href="{{widget_url}}"><span class="glyphicon glyphicon-new-window"></span></a>
     <a href="#"><span class="glyphicon glyphicon-edit"></span></a>
   </div>
   <div class="panel-body">
diff --git a/hubs/widgets/subscriptions.py b/hubs/widgets/subscriptions.py
new file mode 100644
index 0000000..f37819f
--- /dev/null
+++ b/hubs/widgets/subscriptions.py
@@ -0,0 +1,48 @@
+#from hubs.hinting import hint, prefixed as _
+from hubs.widgets.base import argument
+from hubs.widgets.chrome import panel
+
+from hubs import validators
+
+import hubs.models
+
+from fedmsg.meta.base import BaseConglomerator as BC
+
+import jinja2
+
+chrome = panel('Hubs', key='associations')
+template = jinja2.Template("""
+{% if associations %}
+    {% if memberships %}
+        <p>Belongs to: {{memberships_text}}</p>
+    {% endif %}
+    <hr/>
+    {% if subscriptions %}
+        <p>Subscribes to: {{subscriptions_text}}</p>
+    {% endif %}
+{% endif %}
+""")
+
+
+@argument(name="username",
+          default=None,
+          validator=validators.username,
+          help="A FAS username.")
+def data(session, widget, username):
+    user = hubs.models.User.by_username(session, username)
+    ownerships = [u.name for u in user.ownerships]
+    memberships = [u.name for u in user.memberships]
+    subscriptions = [u.name for u in user.subscriptions]
+    return dict(
+        associations=memberships + ownerships,
+        ownerships=ownerships,
+        memberships=memberships,
+        subscriptions=subscriptions,
+        ownerships_text=BC.list_to_series(ownerships),
+        memberships_text=BC.list_to_series(memberships),
+        subscriptions_text=BC.list_to_series(subscriptions),
+    )
+
+
+def should_invalidate(message, session, widget):
+    raise NotImplementedError()
diff --git a/populate.py b/populate.py
index 3c517f4..9e02e82 100755
--- a/populate.py
+++ b/populate.py
@@ -15,7 +15,7 @@ users = ['mrichard', 'duffy', 'ryanlerch', 'gnokii', 'nask0',
 for username in users:
     fullname = 'Full Name Goes Here'
     openid = '%s.id.fedoraproject.org' % username
-    print "Creating account for %r" % openid
+    print("Creating account for %r" % openid)
     hubs.models.User.get_or_create(
         session, openid=openid, fullname=fullname)
 

